<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
*
* @version $Id: ps_paymate.php 1095 2007-12-19 20:19:16Z soeren_nb $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2007 soeren - All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*
*Original Code By Jos Celano (josecelano)
*Modified/Improved by Yos Okusanya
*Email: yosolu@sankuru.biz
*License: GPL - General Public License
*/

/*
* This class implements the log function of the 4b plugin
* 
*/

class ps_vm4b_log {

	var $file = "classes/Log/4b.php";
  
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
	function logError($message) 
	{	
		$this->write_log($message);	
	}
	
	function logExtensive($message)
	{
		$this->write_log($message);
	}
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function logfile_writeable() {
      return is_writeable( $this->file );
	    //return is_writeable( CLASSPATH."Log/4b.php" );
   }
   
  /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function logfile_readable() {
      return is_readable( $this->file );
	  //return is_readable( CLASSPATH."Log/4b.php" );
   }
   
  /**
	* Writes to log file
	* @param array string(message)
	* @returns boolean True when writing was successful
	*/
   function write_log( $message ) 
   {
		if($this->logfile_exists())
		{
			if($this->logfile_writeable())
			{
				$log = date("d-M-Y h:i a")." ".$message."\n";
			       
				  if ($fp = fopen($this->file, "a")) {
			          fputs($fp, $log, strlen($log));
			          fclose ($fp);
			          return true;
			     }
			     else
			        return false;
			}
		}
   }
   
   /**
	* Checks if log file exisits
	* if not create it
	* returns boolean True when writing was successful
	*/
    function logfile_exists() 
   {   
		if(!file_exists($this->file))
		{
			$fh = fopen($this->file, "a");
			
			if($fh==false)
			{
				return false;
			}
			
			//set permission on new file
			chmod($this->file, 0777);
			
			//write header
			$header = "<?php die('Direct Access To Log Files Not Permitted'); ?>\n";
			
			fputs($fh, $header, strlen($header));
			fclose ($fh);
		}		
		return true;
   }
 
}
