<?php
function com_install()
{
	jimport('joomla.filesystem.file');
	
	$vm_root_dir = JPATH_ADMINISTRATOR."/components/com_virtuemart";
	$vm4b_files_dir = JPATH_ADMINISTRATOR."/components/com_vm4b/vm_files";
	
	$db=JFactory::getDBO();
				
	$conf=new JConfig();	
	
	$status = true;
	
	//update populate vm4b currency table
	$q = "SELECT count(*) FROM #__4b_currencies";
	$db->setQuery($q);
	$count = $db->loadResult();
	
	if($count == 0)
	{
		$q = "INSERT INTO #__4b_currencies (curr_3_code, s4b_curr_code) VALUES
		('ALL', '008'),
		('DZD', '012'),
		('ARS', '032'),
		('AUD', '036'),
		('BSD', '044'),
		('BHD', '048'),
		('BDT', '050'),
		('AMD', '051'),
		('BBD', '052'),
		('BMD', '060'),
		('BTN', '064'),
		('BOB', '068'),
		('BWP', '072'),
		('BZD', '084'),
		('SBD', '090'),
		('BND', '096'),
		('MMK', '104'),
		('BIF', '108'),
		('KHR', '116'),
		('CAD', '124'),
		('CVE', '132'),
		('KYD', '136'),
		('LKR', '144'),
		('CLP', '152'),
		('CNY', '156'),
		('COP', '170'),
		('KMF', '174'),
		('CRC', '188'),
		('HRK', '191'),
		('CUP', '192'),
		('CZK', '203'),
		('DKK', '208'),
		('DOP', '214'),
		('ETB', '230'),
		('ERN', '232'),
		('EEK', '233'),
		('FKP', '238'),
		('FJD', '242'),
		('DJF', '262'),
		('GMD', '270'),
		('GIP', '292'),
		('GTQ', '320'),
		('GNF', '324'),
		('GYD', '328'),
		('HTG', '332'),
		('HNL', '340'),
		('HKD', '344'),
		('HUF', '348'),
		('ISK', '352'),
		('INR', '356'),
		('IDR', '360'),
		('IRR', '364'),
		('IQD', '368'),
		('ILS', '376'),
		('JMD', '388'),
		('JPY', '392'),
		('KZT', '398'),
		('JOD', '400'),
		('KES', '404'),
		('KPW', '408'),
		('KRW', '410'),
		('KWD', '414'),
		('KGS', '417'),
		('LAK', '418'),
		('LBP', '422'),
		('LSL', '426'),
		('LVL', '428'),
		('LRD', '430'),
		('LYD', '434'),
		('LTL', '440'),
		('MOP', '446'),
		('MWK', '454'),
		('MYR', '458'),
		('MVR', '462'),
		('MRO', '478'),
		('MUR', '480'),
		('MXN', '484'),
		('MNT', '496'),
		('MDL', '498'),
		('MAD', '504'),
		('OMR', '512'),
		('NAD', '516'),
		('NPR', '524'),
		('ANG', '532'),
		('AWG', '533'),
		('VUV', '548'),
		('NZD', '554'),
		('NIO', '558'),
		('NGN', '566'),
		('NOK', '578'),
		('PKR', '586'),
		('PAB', '590'),
		('PGK', '598'),
		('PYG', '600'),
		('PEN', '604'),
		('PHP', '608'),
		('QAR', '634'),
		('RUB', '643'),
		('RWF', '646'),
		('SHP', '654'),
		('STD', '678'),
		('SAR', '682'),
		('SCR', '690'),
		('SLL', '694'),
		('SGD', '702'),
		('VND', '704'),
		('SOS', '706'),
		('ZAR', '710'),
		('SZL', '748'),
		('SEK', '752'),
		('CHF', '756'),
		('SYP', '760'),
		('THB', '764'),
		('TOP', '776'),
		('TTD', '780'),
		('AED', '784'),
		('TND', '788'),
		('UGX', '800'),
		('MKD', '807'),
		('EGP', '818'),
		('GBP', '826'),
		('TZS', '834'),
		('USD', '840'),
		('UYU', '858'),
		('UZS', '860'),
		('WST', '882'),
		('YER', '886'),
		('ZMK', '894'),
		('TWD', '901'),
		('CUC', '931'),
		('ZWL', '932'),
		('TMT', '934'),
		('GHS', '936'),
		('VEF', '937'),
		('SDG', '938'),
		('RSD', '941'),
		('MZN', '943'),
		('AZN', '944'),
		('RON', '946'),
		('CHE', '947'),
		('CHW', '948'),
		('TRY', '949'),
		('XAF', '950'),
		('XCD', '951'),
		('XOF', '952'),
		('XPF', '953'),
		('XBA', '955'),
		('XBB', '956'),	
		('XBC', '957'),	
		('XBD', '958'),
		('XAU', '959'),	
		('XDR', '960'),
		('XAG', '961'),
		('XPT', '962'),	
		('SRD', '968'),
		('MGA', '969'),
		('COU', '970'),
		('AFN', '971'),
		('TJS', '972'),
		('AOA', '973'),
		('BYR', '974'),
		('BGN', '975'),
		('CDF', '976'),
		('BAM', '977'),
		('EUR', '978'),
		('MXV', '979'),
		('UAH', '980'),
		('GEL', '981'),
		('BOV', '984'),
		('PLN', '985'),
		('BRL', '986'),
		('CLF', '990'),
		('USN', '997'),
		('USS', '998'),
		('XXX', '999')
		";
		$db->setQuery($q);
		
		if(!$db->query())
		{
			echo "There was an error updating the currency table <br>";
			$status = false;
		}
		else
		{
				echo "4B Currency table updated <br>";
		}
	}	

	if(JFile::exists($vm_root_dir."/virtuemart.cfg.php"))
	{
		//=====================check folder permission==========================
		if( $conf->ftp_enable!=true)
		{
			$all_folders_writable = true;
			$folder_msg = "The following folders need to be writable before vm4B can be installed<br>";

			$check_folders = array($vm_root_dir,
									$vm_root_dir.'/classes/payment',
									$vm_root_dir.'/classes/Log',
									$vm_root_dir.'/html',
									$vm_root_dir.'/languages',			
								);
			foreach($check_folders as $folder)
			{
				if(!is_writable($folder))
				{
					$all_folders_writable = false;
					$folder_msg .= $folder."<br>";
				}
			}		
		}
		//===========================end===================================	
		if( $conf->ftp_enable==true or ($all_folders_writable == true))
		{
			$vm4b_files=array(
						array(
								'file_name'=>'vm4b_notify.php',
								'copy_to'=>'/'
							),
						array(
								'file_name'=>'vm4b_requestdetails.php',
								'copy_to'=>'/'
							),
						array(
								'file_name'=>'ps_4b.php',
								'copy_to'=>'/classes/payment/'
							),
						array(
								'file_name'=>'ps_vm4b_log.php',
								'copy_to'=>'/classes/payment/'
							),
						array(
								'file_name'=>'checkout.s4bthankyou.php',
								'copy_to'=>'/html/'
							),
						array(
								'file_name'=>'checkout.s4b_success.php',
								'copy_to'=>'/html/'
							),
						array(
								'file_name'=>'checkout.s4b_failure.php',
								'copy_to'=>'/html/'
							),
					);
				
			$status = true;
			
			foreach($vm4b_files as $vm4b_file)
			{			
				$src = $vm4b_files_dir.$vm4b_file['copy_to'].$vm4b_file['file_name'];
				$dest = $vm_root_dir.$vm4b_file['copy_to'].$vm4b_file['file_name'];
				
				if(JFile::copy($src, $dest) == true)
				{
					echo $vm4b_file['file_name']." copied to admin com_virtuemart".$vm4b_file['copy_to']."<br>";					
				}
				else
				{
					echo "Failed to copy ".$vm4b_file['file_name']."  to admin com_virtuemart".$vm4b_file['copy_to']."<br>";
					$status = false;
				}
			}
			
			if($status)
			{				
				//avoid overwritting 4b.cfg 
				if(JFile::exists($vm_root_dir."/classes/payment/ps_4b.cfg.php") != true)
				{
					if(JFile::copy($vm4b_files_dir."/classes/payment/ps_4b.cfg.php", $vm_root_dir."/classes/payment/ps_4b.cfg.php") == true)
					{	
						echo "ps_4b.cfg.php config file coppied to admin com_virtuemart/classes/payment/ <br>";
					}
					else
					{
						echo "Failed to copy ps_4b.cfg.php to admin com_virtuemart/classes/payment/ <br>";
						$status = false;
					}
				}
				
				//avoid overwritting  log file
				if(JFile::exists($vm_root_dir."/classes/Log/4b.php") != true)
				{
					if(JFile::copy($vm4b_files_dir."/classes/Log/4b.php", $vm_root_dir."/classes/Log/4b.php") == true)
					{						
						echo "4b.php log file coppied to admin com_virtuemart/classes/Log/ <br>";
					}
					else
					{
						echo "Failed to copy 4b.php log file to admin com_virtuemart/classes/Log <br>";
						$status = false;
					}
				}
				
				//avoid overwriting language files
				$language_dir = "/languages/s4b";
				
				if(JFolder::exists($vm_root_dir.$language_dir) != true)
				{			
					if(JFolder::copy($vm4b_files_dir.$language_dir, $vm_root_dir.$language_dir) == true)
					{
						echo "english.php and spanish.php language files coppied to admin com_virtuemart/languages/s4b/ <br>";						
					}
					else
					{
						echo "Failed to copy english.php and spanish.php language files to admin com_virtuemart/languages/s4b <br>";
						$status = false;
					}
					
				}
				else
				{
					if(JFile::exists($vm_root_dir.$language_dir."/english.php") != true)
					{
						if(JFile::copy($vm4b_files_dir.$language_dir."/english.php", $vm_root_dir.$language_dir."/english.php") == true)
						{
							echo "english.php coppied to admin com_virtuemart/languages/s4b/ <br>";
						}
						else
						{
							echo "Failed to copy english.php to admin com_virtuemart/languages/s4b <br>";
							$status = false;
						}
					}
					if(JFile::exists($vm_root_dir.$language_dir."/spanish.php") != true)
					{
						if(JFile::copy($vm4b_files_dir.$language_dir."/spanish.php", $vm_root_dir.$language_dir."/spanish.php") == true)
						{
							echo "spanish.php coppied to admin com_virtuemart/languages/s4b/ <br>";
						}
						else
						{
							echo "Failed to copy spanish.php to admin com_virtuemart/languages/s4b <br>";
							$status = false;
						}
					}
				}
								
			}
			
			//update vm payment method table
			if($status)
			{
				
				$extra_info = '
<?php

	require_once(CLASSPATH.\'payment/ps_4b.cfg.php\');
	
	global $VM_LANG;
	

	$url = S4B_SERVER_URL;
	
	$lang = S4B_TRANSACTION_LANG;
	
	$store = S4B_STORE_ID;
	
	$enforce_lang = S4B_SINGLE_LANG;

	$site_active_lang =& JFactory::getLanguage();
	$active_lang = trim($site_active_lang->get(\'tag\'));
	$active_lang = explode(\'-\', $active_lang);
	$site_lang =  $active_lang[0];
	
	$active_lang_name = trim($site_active_lang->get(\'backwardlang\'));
	
	if( file_exists(ADMINPATH.\'languages/s4b/\'.$active_lang_name.\'.php\')) {
		require_once(ADMINPATH.\'languages/s4b/\'.$active_lang_name.\'.php\');
	} 
	else {
		require_once(ADMINPATH.\'languages/s4b/spanish.php\');
	}
	
	$order_id = $db->f(order_id);

	
	$tax_total = $db->f("order_tax") + $db->f("order_discount");
	$discount_total = $db->f("coupon_discount") + $db->f("order_discount");
	$order_total = round($db->f("order_subtotal") + $db->f("order_shipping") + $tax_total - $discount_total, 2);
	
	
?>


	<p><?php echo PHPSHOP_S4B_PAYMENT_STAGE;printf("%00.2f", $order_total);echo $db->f("order_currency").")<br><p>".
	PHPSHOP_S4B_PAYMENT_STAGE_LBL ?><br>
	
	<br><br>


	<form action="<?php echo $url;?>" method="post">
		<INPUT type="hidden" name="ordernum" value="<?php echo $order_id?>">		
		<input type="hidden" name="store" value="<?php echo $store?>"/>
 <?php if($enforce_lang){?>		
		<input type="hidden" name="idioma" value="<?php echo $lang?>"/>
 <?php }else{?>
                <span><?php echo PHPSHOP_S4B_PAYMENT_STAGE_LANG_SEL ?></span>
		 <select name="idioma" class="inputbox" >
	                <option <?php if ($site_lang == \'es\') echo "selected=\'selected\'"; ?> value="es"><?php echo PHPSHOP_S4B_LANG_ES ?></option>
	                <option <?php if ($site_lang == \'en\') echo "selected=\'selected\'"; ?> value="en"><?php echo PHPSHOP_S4B_LANG_EN ?></option>
					<option <?php if ($site_lang == \'fr\') echo "selected=\'selected\'"; ?> value="fr"><?php echo PHPSHOP_S4B_LANG_FR ?></option>
	                <option <?php if ($site_lang == \'ca\') echo "selected=\'selected\'"; ?> value="ca"><?php echo PHPSHOP_S4B_LANG_CA ?></option>
               </select>
 <?php }?>				
		<input type="submit" name="Submit" value="<?php echo PHPSHOP_S4B_PAYMENT_STAGE_SUBMIT ?>" />
		
	</form>
 <?php
 ?>
';
				$extra_info = addslashes($extra_info);

				$q = "INSERT INTO #__vm_payment_method 
				(`payment_method_id`, `vendor_id`, `payment_method_name`, `payment_class`, `shopper_group_id`, 
				`payment_method_discount`, `payment_method_discount_is_percent`, `payment_method_discount_max_amount`, 
				`payment_method_discount_min_amount`, `list_order`, `payment_method_code`, `enable_processor`, 
				`is_creditcard`, `payment_enabled`, `accepted_creditcards`, `payment_extrainfo`, `payment_passkey`)
				VALUES
				(NULL, 1, 'Sistema 4B', 'ps_4b', 5, 0.00, 0, 0.00, 0.00, 0, 'S4B', 'P', 0, 'N', '', '$extra_info', '')
				";
	
				$db->setQuery($q);
				
				if(!$db->query())
				{
					echo 'There was a problem updating the vm payment method table<br>';
					echo $db->getErrorMsg().'<br>';
					$status = false;					
				}			
			}
			
		}
		else
		{
			echo 'This Component can only be installed if the ftp layer is enabled<br>';
			echo "OR<br> $folder_msg";
			$status = false;
		}
		
	}
	else
	{
		echo 'Virtuemart not detected.<br>This Component can only be installed if the Virtuemart has been pre-installed<br>';
		$status = false;
	}
	
	if(!$status)
	{
		$installer =& JInstaller::getInstance();
		array_pop($installer->_stepStack);

		$db=JFactory::getDBO();
		$q="DELETE FROM #__components WHERE `option`='com_vm4b'";
		$db->setQuery($q);
		$db->query();
	}
	
	return $status;
}		
?>