<?php
	defined( '_JEXEC' ) or die( 'Restricted access' );
	jimport('joomla.application.component.view');
	class JViewOrders extends JView
	{
		function display($tpl = null)
		{	
			global $option, $mainframe;
			
			$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
			$limitstart = JRequest::getVar('limitstart', 0);
			
			$keyword = JRequest::getVar('keyword');
			$from_date = JRequest::getVar('from_date');
			$to_date = JRequest::getVar('to_date');
			$reset_all = JRequest::getVar('reset_all');
			
			if($reset_all)
			{
				UNSET($keyword);
				UNSET($from_date);
				UNSET($to_date);
			}
			
			if($keyword)
			{
				$keword_query = " (orderid LIKE '%$keyword%' OR transid LIKE '%$keyword%' OR transtype LIKE '%$keyword%' 
							OR authcode LIKE '%$keyword%' OR errorcode LIKE '%$keyword%' OR deserror LIKE '%$keyword%') ";
			}
			
			if($from_date or $to_date)
			{
				if($from_date and $to_date)
				{
					$date_query = " `date` between '$from_date' and '$to_date' ";
				}
				elseif($from_date)
				{
					$date_query = " `date` >= '$from_date' ";
				}
				else
				{
					$date_query = " `date` <= '$to_date' ";
				}
			}
			
			if($keyword or $from_date or $to_date)
			{
				if($keyword and ($from_date or $to_date))
				{
					$where_clause = " WHERE $keword_query  AND $date_query ";
				}
				else
				{
					$where_clause = " WHERE $keword_query $date_query ";
				}
			}
			
						
			$model = &$this->getModel();
			
			$orders = $model->getAllOrders($where_clause, $limitstart, $limit);
			
			$total = $model->countRows();
			
			jimport('joomla.html.pagination');
			$pageNav = new JPagination($total, $limitstart, $limit);
						
			$this->assignRef('orders', $orders);
			$this->assignRef('pageNav', $pageNav);
			
			$this->assignRef('keyword', $keyword);
			$this->assignRef('from_date', $from_date);
			$this->assignRef('to_date', $to_date);
			
			//echo $where_clause;die();
			
			parent::display($tpl); 
		}
	}
?>